<template>
<div>
  <el-row type="flex" justify="center" >
    <el-col :span="20">
      <el-table :data="tableData" border>
        <el-table-column
          prop="repo_url"
          label="Merge Request Url">
        <template slot-scope="scope">
          <a style="cursor:pointer" :href="scope.row.repo_url">{{scope.row.repo_url}}</a>
          </template>
        </el-table-column>
        <el-table-column prop="approved_by" label="Approved By" width="180">
          <template slot-scope="scope">
            <div
              slot="reference"
              v-for="item in scope.row.approved_by"
              :key="item.index"
            >
              {{ item }}
            </div>
          </template>
        </el-table-column>
        <el-table-column
          prop="no_of_approvers"
          label="No. of approvers required"
          width="130"
        ></el-table-column>
        <el-table-column
          prop="eligible_approvers"
          label="Mandatory Approvers"
          width="180"
        >
          <template slot-scope="scope">
            <div
              slot="reference"
              v-for="item in scope.row.eligible_approvers"
              :key="item.index"
            >
              {{ item }}
            </div>
          </template>
        </el-table-column>
        <el-table-column prop="status" label="Status" width="100">
          <template slot-scope="scope">
            <div slot="reference" v-if="scope.row.status">
              <el-button type="primary" @click="clickMerge" :disabled="!email">Merge</el-button>
            </div>
            <div slot="reference" v-else>
              <el-button type="danger" disabled>Merge</el-button>
            </div>
          </template>
        </el-table-column>
        <el-table-column
          prop="conflict"
          label="Comment"
        ></el-table-column>
      </el-table>
    </el-col>
  </el-row>
</div>
  
</template>
<script>
import { mapState } from "vuex";
export default {
  data() {
    return {
      tableData: undefined,
      state : undefined, 
      url: `/${this.$route.params.project_id}/${this.$route.params.merge_request_id}/merge`,
      mergeUrl: `/${this.$route.params.project_id}/merge_requests/${this.$route.params.merge_request_id}/merge`,
    };
  },
  computed: {
    ...mapState({
      email: (state) => state.email,
    }),
  },
  methods: {
    clickMerge() {
      const config = {
        method: "post",
        url: this.mergeUrl,
        data: {requrl : this.tableData[0].repo_url},
      };
      this.$axios(config)
        .then((res) => {
          alert('Merged') ? "" : location.reload();
          console.log(res);
        })
        .catch((err) => {
          console.log(err);
        });
    },
  },
  mounted() {
    const config = {
      method: "get",
      url: this.url,
    };
    this.$axios(config)
      .then((res) => {
        this.tableData = res.data;
        this.state = this.tableData[0].state
        // console.log(res)
      })
      .catch((err) => {
        console.log(err);
      });
    
  },
};
</script>